package com.iformall.controller;

import com.github.pagehelper.PageInfo;
import com.iformall.common.Result;
import com.iformall.common.ResultData;
import com.iformall.domain.po.WxCouponSpread;
import com.iformall.service.WxCouponSpreadService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping("wxCouponSpread")
@Api(description = "推广接口")
public class WxCouponSpreadController extends BaseController {
    private final Logger logger = LoggerFactory.getLogger(this.getClass());

    @Autowired
    private WxCouponSpreadService wxCouponSpreadService;

    @ApiOperation("分页列表接口")
    @GetMapping("list")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "页数", dataType = "int", paramType = "query", required = true),
            @ApiImplicitParam(name = "pageSize", value = "每页条数", dataType = "int", paramType = "query", required = true)})
    public ResultData list(@ModelAttribute WxCouponSpread wxCouponSpread, Integer pageNum, Integer pageSize) {
        logger.debug("[" + getIpAddr() + "] WxCouponSpreadController::list");
        if (null == wxCouponSpread) wxCouponSpread = new WxCouponSpread();
        final PageInfo<WxCouponSpread> page = wxCouponSpreadService.listAsPage(wxCouponSpread, pageNum, pageSize);
        return new ResultData(page);
    }

    @ApiOperation("新增接口")
    @PostMapping("add")
    public ResultData add(@RequestBody WxCouponSpread wxCouponSpread) {
        logger.debug("[" + getIpAddr() + "] WxCouponSpreadController::add");
        if (wxCouponSpread.getCouponId() == null) {
            return new ResultData(Result.ERROR, "没有找到券id");
        }
        //Assert.notNull(wxCouponSpread.getName(), "角色名不能为空");
        //Assert.isTrue(!checkUnique(sysRole.getName(), null), "重复的角色名");
        wxCouponSpreadService.saveOrUpdate(wxCouponSpread);
        return new ResultData();
    }

    @ApiOperation("根据id更新接口")
    @PostMapping("update")
    public ResultData update(@RequestBody WxCouponSpread wxCouponSpread) {
        logger.debug("[" + getIpAddr() + "] WxCouponSpreadController::update");
        wxCouponSpreadService.saveOrUpdate(wxCouponSpread);
        return new ResultData();
    }

    @ApiOperation("根据id删除接口")
    @GetMapping("/del")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    public ResultData delete(Long id) {
        logger.debug("[" + getIpAddr() + "] WxCouponSpreadController::delete");
        wxCouponSpreadService.deleteById(id);
        return new ResultData(Result.SUCCESS, "删除成功", null);
    }

    @ApiOperation("根据id查询接口")
    @GetMapping("/findById")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    public ResultData findById(Long id) {
        logger.debug("[" + getIpAddr() + "] WxCouponSpreadController::findById");
        return new ResultData(Result.SUCCESS, "查询成功", wxCouponSpreadService.getById(id));
    }

    @ApiOperation("根据卡券id查询接口")
    @GetMapping("/findByCouponId")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    public ResultData findByCouponId(Long id) {
        logger.debug("[" + getIpAddr() + "] WxCouponSpreadController::findByCouponId");
        WxCouponSpread result = null;
        if (id != null) {
            WxCouponSpread wxCouponSpread = new WxCouponSpread();
            wxCouponSpread.setCouponId(id);
            List<WxCouponSpread> list = wxCouponSpreadService.findList(wxCouponSpread);
            if (!list.isEmpty()) {
                result = list.get(0);
            }
        }
        return new ResultData(Result.SUCCESS, "查询成功", result);
    }


}
